/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "kxmain.h"

#include <qfile.h>
#include <qdir.h>


void kxMain :: Generate ()
{
int a = 0;

x->removeSection("Files", 1);

if (rgbGroupBox->isChecked() || modulesPathGroupBox->isChecked() || fontsGroupBox->isChecked())
{
x->addSection("Files");
//RGB Path
if (rgbGroupBox->isChecked() && RGBPathRequester->url() != "") { x->saveValue("Files", 1, "RgbPath", 1, RGBPathRequester->url()); }
if (modulesPathListBox->count() > 0 && modulesPathGroupBox->isChecked())
{
int a = 0;
while (a < modulesPathListBox->count())
{
x->replaceSomething(x->section("Files", 1), x->section("Files", 1).append ("ModulePath \"" + modulesPathListBox->text(a) + "\"\n"));
a++;
}
}

if (fontsBox->count() > 0 && fontsGroupBox->isChecked())
{
int a = 0;
while (a < fontsBox->count())
{
x->replaceSomething(x->section("Files", 1), x->section("Files", 1).append ("FontPath \"" + fontsBox->text(a) + "\"\n"));
a++;
}
}




}

QString config = x->returnConfig();

config = config.replace("\n", "|");
config = config.simplifyWhiteSpace();
config = config.replace("|", "\n");
config = config.replace("\n ", "\n");
while (a < 1000)
{
config = config.replace("\n\n", "\n");
a++;
}


config = config.prepend("# This file was created by kX Generator 0.2.3 by Tomasz Salacinski\n"
                        "# BETA VERSION. Make backup copy of your original xorg.conf file!\n\n");

config = config.append("\"");
config = config.remove("Option \"Device\" \"(None)\"\n");

//Making it look better
config = config.replace("\nIdentifier ",    "\n   Identifier    ");
config = config.replace("\nDriver ",        "\n   Driver        ");
config = config.replace("\nInputDevice ",   "\n   InputDevice   ");
config = config.replace("\nScreen ",        "\n   Screen        ");
config = config.replace("\nRgbPath ",       "\n   RgbPath       ");
config = config.replace("\nFontPath ",      "\n   FontPath      ");
config = config.replace("\nModulePath ",    "\n   ModulePath    ");
config = config.replace("\nLoad ",          "\n   Load          ");
config = config.replace("\nOption ",        "\n   Option        ");
config = config.replace("\nGamma ",         "\n   Gamma         ");
config = config.replace("\nVendorName ",    "\n   VendorName    ");
config = config.replace("\nModelName ",     "\n   ModelName     ");
config = config.replace("\nHorizSync ",     "\n   HorizSync     ");
config = config.replace("\nVertRefresh ",   "\n   VertRefresh   ");
config = config.replace("\nDevice ",        "\n   Device        ");
config = config.replace("\nMonitor ",       "\n   Monitor       ");
config = config.replace("\nDefaultDepth ",  "\n   DefaultDepth ");
config = config.replace("\nSubSection ",    "\n        SubSection ");
config = config.replace("\nDepth ",         "\n           Depth ");
config = config.replace("\nModes ",         "\n           Modes ");
config = config.replace("\nEndSubSection",  "\n        EndSubSection");
config = config.replace("\nEndSection",    "\nEndSection\n\n");
config = config.remove("\n\"", "");

a = 0;
QString num;
while (a < x->returnSecNum())
{
num = num.setNum(a, 10);
config = config.remove("# " + num + QChar(10));
a++;
}
a = 0;

while (a < 1000)
{
num = num.setNum(a, 10);
num = num.append("-").prepend("\"");
config = config.replace(num, "\"");
a++;
}



if (groupBox17_2->isChecked())
{
if (commentCheckBox->isChecked())
{
config = config.append("# ").append(commentEdit->text()).append("\n");
}
config = config.append(textEdit1->text());

}



QString script =
"mv /etc/X11/xorg.conf /etc/X11/xorg.conf.kxbackup\n"
"mv /tmp/xorg.conf /etc/X11/\n"
"mv /tmp/returnXorg /usr/bin/\n"
"chmod 777 /usr/bin/returnXorg\n"
"rm -fr /tmp/xorgConfScript.sh\n";

QFile *file = new QFile("/tmp/xorg.conf");
file->open(IO_WriteOnly);
file->writeBlock(config, config.length());
file->close();
file->setName("/tmp/xorgConfScript.sh");
file->open(IO_WriteOnly);
file->writeBlock(script, script.length());
file->close();

file->setName("/tmp/returnXorg");
file->open(IO_WriteOnly);


script =
"rm -fr /etc/X11/xorg.conf\n"
"mv /etc/X11/xorg.conf.kxbackup /etc/X11/xorg.conf";
file->writeBlock(script, script.length());
file->close();


KProcess *chmod = new KProcess;
*chmod << "chmod" << "777" << "/tmp/xorgConfScript.sh";
chmod->start();



saveFileProcess = new KProcess;
*saveFileProcess << "kdesu" << "-d" << "-i" << "kxgenerator" << "-c" << "sh /tmp/xorgConfScript.sh" << "--caption" << "kX Generator";


connect(saveFileProcess, SIGNAL(processExited(KProcess *)), this, SLOT(showInfo()));
saveFileProcess->start();

}




void kxMain :: showInfo()
{

if (saveFileProcess->normalExit())
{
QMessageBox::information(this, "kX Generator", tr("File created. If X does not start, log in as normal user and type:\n"
                                                  "su\n"
                                                  "then enter your root password and hit return. When you'll work as root, type:\n"
                                                  "returnXorg\n"
                                                  "and your original xorg.conf file will be replaced. After that, just type\n"
                                                  "exit\n"
                                                  "To start X server, type: \nstartx"));
}
else
{
QMessageBox::information(this, "kX Generator", tr("Changes NOT saved."));
}

}