/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "mousedriverdialog.h"

mouseDriverDialog::mouseDriverDialog(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :mouse_drv_options(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);
sectNum = sectionNum;
setLocale();
//Getting protocol

if (x->getOption("InputDevice", sectNum, "Protocol") != "")
{
int a = 0;
while (a <= comboBox10->count())
{
if (comboBox10->text(a).lower() == x->getOption("InputDevice", sectNum, "Protocol").lower()) {comboBox10->setCurrentItem(a); break; }
a++;
}
}
if (x->getOption("InputDevice", sectNum, "Buttons") != "")
{
bool ok;
QString num = x->getOption("InputDevice", sectNum, "Buttons");
int a = num.toInt(&ok, 10);
comboBox20->setCurrentItem(a);
}

if(x->checkOption("InputDevice", sectNum, "Emulate3Buttons")) { 
groupBox20->setChecked(TRUE); 
bool ok;
QString num = x->getOption("InputDevice", sectNum, "Emulate3Timeout");
int a = num.toInt(&ok, 10);
kIntSpinBox6->setValue(a);
}
if(x->checkOption("InputDevice", sectNum, "ChordMiddle")) { checkBox35->setChecked(TRUE); }
if(x->checkOption("InputDevice", sectNum, "ClearDTR")) { checkBox11->setChecked(TRUE); }
if(x->checkOption("InputDevice", sectNum, "ClearRTS")) { checkBox12->setChecked(TRUE); }



if (x->getOption("InputDevice", sectNum, "Resolution") != "")
{
checkBox34->setChecked(FALSE);
bool ok;
QString num = x->getOption("InputDevice", sectNum, "Resolution");
int a = num.toInt(&ok, 10);
kIntSpinBox3->setValue(a);
}

if (x->getOption("InputDevice", sectNum, "SampleRate") != "")
{
checkBox33->setChecked(FALSE);
bool ok;
QString num = x->getOption("InputDevice", sectNum, "SampleRate");
int a = num.toInt(&ok, 10);
kIntSpinBox2->setValue(a);
}


if (x->getOption("InputDevice", sectNum, "BaudRate") == "") { comboBox21->setCurrentItem(0); }
if (x->getOption("InputDevice", sectNum, "BaudRate") != "") { 
QString s = x->getOption("InputDevice", sectNum, "BaudRate");
if (s == "300") { comboBox21->setCurrentItem(1); }
if (s == "1200") { comboBox21->setCurrentItem(2); }
if (s == "2400") { comboBox21->setCurrentItem(3); }
if (s == "4800") { comboBox21->setCurrentItem(4); }
if (s == "9600") { comboBox21->setCurrentItem(5); }
if (s == "19200") { comboBox21->setCurrentItem(6); }
}

if(x->checkOption("InputDevice", sectNum, "EmulateWheel")) { 
groupBox25->setChecked(TRUE);
bool sok;
QString num;
int a;
num = x->getOption("InputDevice", sectNum, "EmulateWheelButton");
a = num.toInt(&sok, 10);
comboBox22->setCurrentItem(a - 1);
num = x->getOption("InputDevice", sectNum, "EmulateWheelInertia");
a = num.toInt(&sok, 10);
spinBox9->setValue(a);
num = x->getOption("InputDevice", sectNum, "EmulateWheelTimeout");
a = num.toInt(&sok, 10);
spinBox10->setValue(a);


}


if(x->checkOption("InputDevice", sectNum, "FlipXY")) { 
groupBox23->setChecked(TRUE);
if(x->checkOption("InputDevice", sectNum, "InvX")) { checkBox30->setChecked(TRUE); }
if(x->checkOption("InputDevice", sectNum, "InvY")) { checkBox31->setChecked(TRUE); }
if (x->getOption("InputDevice", sectNum, "AngleOffset") != "") 
{
bool sok;
QString num = x->getOption("InputDevice", sectNum, "AngleOffset");
int a = num.toInt(&sok, 10);
kIntSpinBox9->setValue(a);
}

}


}


void mouseDriverDialog :: sampleRateHandler()
{
if (checkBox33->isChecked())
{
kIntSpinBox2->setEnabled(FALSE);
textLabel27->setEnabled(FALSE);
}
if (!checkBox33->isChecked())
{
kIntSpinBox2->setEnabled(TRUE);
textLabel27->setEnabled(TRUE);
}




}
void mouseDriverDialog :: resolutionHandler()
{
if (checkBox34->isChecked())
{
kIntSpinBox3->setEnabled(FALSE);
textLabel28->setEnabled(FALSE);
}
if (!checkBox34->isChecked())
{
kIntSpinBox3->setEnabled(TRUE);
textLabel28->setEnabled(TRUE);
}




}




QString mouseDriverDialog :: returnXorg()
{
return x->returnConfig();
}

void mouseDriverDialog :: accept()
{
QString y = "True";
QString n = "False";

x->saveOption("InputDevice", sectNum, "Protocol", 1, comboBox10->text(comboBox10->currentItem()));

if (comboBox21->currentItem() == 0) { x->removeOption("InputDevice", sectNum, "BaudRate"); }
if (comboBox21->currentItem() != 0) { x->saveOption("InputDevice", sectNum, "BaudRate", 1, comboBox21->text(comboBox21->currentItem()).remove(" (default)")); }



if (checkBox35->isChecked()) { x->saveOption("InputDevice", sectNum, "ChordMiddle", 1, y); }
if (!checkBox35->isChecked()) { x->removeOption("InputDevice", sectNum, "ChordMiddle"); }
if (checkBox11->isChecked()) { x->saveOption("InputDevice", sectNum, "ClearDTR", 1, y); }
if (!checkBox11->isChecked()) { x->removeOption("InputDevice", sectNum, "ClearDTR"); }
if (checkBox12->isChecked()) { x->saveOption("InputDevice", sectNum, "ClearRTS", 1, y); }
if (!checkBox12->isChecked()) { x->removeOption("InputDevice", sectNum, "ClearRTS"); }
if (comboBox20->currentItem() == 0) { x->removeOption("InputDevice", sectNum, "Buttons"); }
if (comboBox20->currentItem() != 0) { x->saveOption("InputDevice", sectNum, "Buttons", 1, comboBox20->text(comboBox20->currentItem())); }
if (!checkBox33->isChecked())
{
QString num;
num = num.setNum(kIntSpinBox2->value(), 10);
x->saveOption("InputDevice", sectNum, "SampleRate", 1, num);
}
if (checkBox33->isChecked())
{
x->removeOption("InputDevice", sectNum, "SampleRate");
}

if (!checkBox34->isChecked())
{
QString num;
num = num.setNum(kIntSpinBox3->value(), 10);
x->saveOption("InputDevice", sectNum, "Resolution", 1, num);
}
if (checkBox34->isChecked())
{
x->removeOption("InputDevice", sectNum, "Resolution");
}

if (!groupBox20->isChecked()) { x->removeOption("InputDevice", sectNum, "Emulate3Buttons"); x->removeOption("InputDevice", sectNum, "Emulate3Timeout"); }
if (groupBox20->isChecked()) {
x->saveOption("InputDevice", sectNum, "Emulate3Buttons", 1, y);
QString num;
num = num.setNum(kIntSpinBox6->value(), 10);
x->saveOption("InputDevice", sectNum, "Emulate3Timeout", 1, num);
}

if (!groupBox23->isChecked())
{
x->removeOption("InputDevice", sectNum, "FlipXY");
x->removeOption("InputDevice", sectNum, "InvX");
x->removeOption("InputDevice", sectNum, "InvY");
x->removeOption("InputDevice", sectNum, "AngleOffset");
}


if (groupBox23->isChecked())
{

x->saveOption("InputDevice", sectNum, "FlipXY", 1, y);
if (checkBox30->isChecked()) { x->saveOption("InputDevice", sectNum, "InvX", 1, y); }
if (!checkBox30->isChecked()) { x->saveOption("InputDevice", sectNum, "InvX", 1, n); }
if (checkBox31->isChecked()) { x->saveOption("InputDevice", sectNum, "InvY", 1, y); }
if (!checkBox31->isChecked()) { x->saveOption("InputDevice", sectNum, "InvY", 1, n); }
if (kIntSpinBox9->value() == 0) { x->removeOption("InputDevice", sectNum, "AngleOffset"); }
if (kIntSpinBox9->value() != 0) {
QString num;
num = num.setNum(kIntSpinBox9->value(), 10);
x->saveOption("InputDevice", 1, "AngleOffset", 1, num);
}



}






if (!groupBox25->isChecked())
{
x->removeOption("InputDevice", sectNum, "EmulateWheel");
x->removeOption("InputDevice", sectNum, "EmulateWheelButton");
x->removeOption("InputDevice", sectNum, "EmulateWheelInertia");
x->removeOption("InputDevice", sectNum, "EmulateWheelTimeout");
}
if (groupBox25->isChecked())
{
x->saveOption("InputDevice", sectNum, "EmulateWheel", 1, y);
x->saveOption("InputDevice", sectNum, "EmulateWheelButton", 1, comboBox22->text(comboBox22->currentItem()));
QString num;
num = num.setNum(spinBox9->value(), 10);
x->saveOption("InputDevice", sectNum, "EmulateWheelInertia", 1, num);
num = num.setNum(spinBox10->value(), 10);
x->saveOption("InputDevice", sectNum, "EmulateWheelTimeout", 1, num);
}





close();
}







#include "mousedriverdialog.moc"
